	device zxspectrum128
        ORG #8000
begin
fntp equ $A000
dirp equ $B000
;depack font
	call depack_font

;start boot
sboot:
	xor a:out ($FE),a
	ld a,$47
	call cls
	
;read dir
	ld a,$10
	ld bc,$7ffd
	out (c),a
;zero memory
	ld hl,$A800
	xor a
zm:
	ld (hl),a
	inc hl
	cp h
	jr nz,zm
;read sectors 0-7
	ld hl,$A800
	ld de,0
	ld bc,$0805
	call $3D13
;scan dir
	ld ix,$A800
	ld de,dirp;$D000
sd:
	ld a,(ix+0)
	cp 1 ;deleted?
	jr z,next_file
;0..7      ASCII 
;8         ASCII 
;9..10   
;11..12    
;13        
;14        
;15       
	ld a,(ix+8)
	cp "B"
	jr nz,next_file
	push ix
	pop hl
	
	push de,hl
	ld de,bfn
	ld bc,$800
chk:
	ld a,(de)
	cp (hl)
	jr z,nxtcp
	ld c,1
	jr ex_chk
nxtcp:
	inc de,hl
	djnz chk
ex_chk:
	pop hl,de

	inc c:dec c:jr z,next_file

	ld bc,8
	ldir
next_file:
	ld bc,16
	add ix,bc
	ld a,ixh
	cp $B0
	jr z,ex_sd
	ld a,(ix)
	or a
	jp nz,sd
ex_sd:
;end of
	xor a
	ld (de),a

	ld a,(dirp)
	or a
	jr nz,contboot

	ld ix,nofm
	ld de,$4800+13
	call prt
nt:
	call wkey
	cp $07:jp z,sboot
	jr nt

contboot:
;print shit
	ld ix,dirp
	ld de,$4000
	call prt



;color text
	ld hl,$5800
	ld de,$4647
ct1:
	ld (hl),d:inc hl
	ld a,l:and 3:jr nz,ct1

ct2:
	ld (hl),e:inc hl
	ld a,l:and 3:jr nz,ct2
	
	ld a,l:and 31:jr nz,ct1
	ld a,e,e,d,d,a
	ld a,h
	cp $5B
	jr nz,ct1
	
;bottom line
	ld hl,$5AE0,b,32
bol: ld (hl),$78:inc l:djnz bol
; detect cursor
	ld de,0
	ld a,($D008)
	or a: jr z,single_file
	inc e
single_file:
	ld (cxy),de
	call ramk

	ld ix,title
	ld de,$50E0+11
	call prt

;keyscan
wk:
	call wkey
	ld de,(cxy)
;left
	cp $08:jp z,left
	cp $6F:jp z,left ; o
	
	cp $36:jp z,left ; 6
;right
	cp $09:jp z,right
	cp $70:jp z,right ; p
	
	cp $37:jp z,right ;7
;up
	cp $0B:jp z,up
	cp $71:jp z,up

	cp $38:jp z,up ; 8
;down
	cp $0A:jp z,down
	cp $61:jp z,down

	cp $39:jp z,down ; 9
;run
	cp $0D:jp z,runp

	cp $30:jp z,runp
	cp $20:jp z,runp

	cp $6D:jp z,runp

;edit(CS+1)
	cp $07:jp z,sboot
;x - to 48
	cp $78:jp z,ex48

	jp wk
ex48:
	DI
	ld ix,0
	add ix,sp
	LD	SP,(23613)
	POP	HL
	LD	HL,4867 ; ERR_SP FOR 48-BASIC
	PUSH	HL
	LD	HL,7030 ; CONTINUE INTERPRETATOR 48-BASIC
	PUSH	HL
	RES	4,(IY+1);   128
	LD	DE,5566 ; INFORMATION FOR STREAMS
	LD	HL,(23631) ; CHANS
	LD	BC,15
	ADD	HL,BC
	EX	DE,HL ; DE=ADDR.FOR STREAMS/CHANNELS, HL=5556
	LD	C,4 ; BC=4 FOR LDIR
	LDIR
	ld sp,ix
	EI
	RET
cxy: dw 0
wkey:
	ld a,($5c15)
	ld ($5C16),a
	ld hl,$5C3b
	res 5,(hl)
	ei:halt
	bit 5,(hl)
	jr z,wkey
	ld a,($5C08)
	ret
runp:
	ld l,d
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,hl

	ld l,e
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,dirp;$D000
	add hl,bc
	ex de,hl
	ld hl,(23635)
	ld bc, boot.fna-boot.Basic
	add hl,bc
	ex de,hl
	ld bc,8
	ldir
	ld a,7:out ($FE),a
	ld a,$38
	jp cls

left:
	inc e
	dec e
	jp z,wk

	call ramk
	dec e
	ld (cxy),de
	call ramk

	jp wk

right:
	ld a,e
	inc a
	bit 3,a
	jp nz,wk

	ld l,d
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,hl

	ld l,e
	inc l
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,dirp;$D000
	add hl,bc
	ld a,(hl)
	or a
	jp z,wk
	call ramk
	inc e
	ld (cxy),de
	call ramk
	jp wk

up:
	inc d
	dec d
	jp z,wk

	call ramk
	dec d
	ld (cxy),de
	call ramk
	jp wk

down:
	ld l,d
	inc l
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,hl

	ld l,e
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,dirp;$D000
	add hl,bc
	push hl
	pop ix
	ld a,(ix+32)
	or a
	jp z,wk

	call ramk
	inc d
	ld (cxy),de
	call ramk

	jp wk

ramk:
	push hl,bc
	ld l,d
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,hl

	ld l,e
	ld h,0
	add hl,hl
	add hl,hl
	add hl,bc
	ld bc,$5800
	add hl,bc
	ld b,4
ral:
	ld a,(hl)
	xor 8
	ld (hl),a
	inc hl
	djnz ral
	pop bc,hl
	ret
cls:
	ld hl,$4000
	ld de,$4001
	ld bc,6144
	ld (hl),l
	ldir
	ld (hl),a
	ld bc,767
	ldir
	ret

prt:
prl:
	ld a,(ix+0)
	or a
	ret z
	inc ix
	and 127
	ld l,a
	ld h,fntp/256
	ld b,8
	push de
ch81:
	ld a,(hl)
	ld (de),a
	inc h
	inc d
	djnz ch81
	pop de

	ld a,(ix+0)
	or a
	ret z
	inc ix
	and 127
	ld l,a
	ld h,fntp/256
	ld b,8
	push de
ch82:
	ld a,(hl)
	srl a
	srl a
	srl a
	srl a
	ld c,a
	ld a,(de)
	or c
	ld (de),a
	inc h
	inc d
	djnz ch82
	pop de
	inc e
	jp nz,prl
	ld a,d
	add a,8
	ld d,a
	cp $58
	jp nz,prl

depack_font:
	ld hl,fntp
	ld de,fp
df:
	push hl
	ld b,4
df2:
	ld a,(de)
	and $F0
	ld (hl),a
	inc h
	ld a,(de):inc de
	and $0F
	add a,a
	add a,a
	add a,a
	add a,a
	ld (hl),a
	inc h
	djnz df2
	pop hl
	inc l
	jp p,df
	ret
fp:incbin "pack.fnt"
title: db "Goba boot 16-11-2019",0
bfn: db "boot    "
nofm: db "No Basic files",0
end
;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
    res 4,(iy+1)
;demo
 di
 ld de,(#5CF4)
 ld hl, #8000
 push hl
 
 db 1,5,(end-begin+255)/256
 jp #3d13


 db "yo,lamer!"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 
 db #FD,#B0
 db #22,"32767",$22;#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29;)

 db ":"
 db $F9; randomize
 db $C0; usr
 db $B0; val
 db $22,"15619",$22
 db ":"
 db $EA; rem
 db ":"
 db 247 ; run
 db $22
fna: db "        "
 db $22
 db #0D

 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "dust.trd","boot.C",begin,end-begin

	shellexec "hob2trd ORGBOOT.$b dust.trd"
	shellexec "hob2trd ToJeVul.$b dust.trd"
	shellexec "hob2trd GliderR.$B dust.trd"
	shellexec "hob2trd Gunrunnr.$b dust.trd"
	shellexec "hob2trd Sophistr.$b dust.trd"
	shellexec "hob2trd Hysteria.$b dust.trd"
	shellexec "hob2trd Bobby.$b dust.trd"
	shellexec "hob2trd Petris.$b dust.trd"
	shellexec "hob2trd Asm1_12.$b dust.trd"


